//Purpose:
//This function will edit a look-up or master-detail
//based on the chosen resource name.
//The resource can be mapped to a formula field
//based on the relationship and won't be edited

//Action Type: On Save Event
//Prevent Default Action: Yes

//More info on custom actions here:
//https://www.seedcode.com/pmwiki/index.php?n=DayBackOnline.CustomActions

//the name of the object we're retrieving the id from
var objectName = 'User';
//the name of the name field we're looking up.
var nameField = 'Alias';
//the name of the id/relationship we need to update
var idField = 'OwnerId';


//you shouldn't need to edit below this line

//only run when we have a change to the resource field
if(changesObject.resource) {
  //user is editing the resource value;
  if(changesObject.resource[0] === 'none') {
    //remove if none has been specified in DayBack
    changesObject[idField] = '';
    delete changesObject.resource;
    action.callbacks.confirm();
  }
  else {
    getIdFromName(changesObject.resource[0], objectName, nameField, idField);
  }
}
else {
   action.callbacks.confirm();
}

function getIdFromName(name, objectName, nameField, idField) {

  //retrieve our canvas client object for authentication
  var client = fbk.client();

  //retrieve our canvas context object for REST links/urls
  var context = fbk.context();

  //retrieve the query URL from context
  var url = context.links.queryUrl;

  //encode name for passing as URI component
  name = encodeURIComponent(name).replace(/'/g, "\\'");

  //create SOQL statement
  var soql = 'SELECT+ID+FROM+' + objectName + '+WHERE+' + nameField + '=\'' + name + '\'';

  //final URL for GET
  var finalUrl = url + '?q=' + soql;

  //build settings object for Ajax call to Salesforce
  var settings = {};
  settings.client = client;
  settings.contentType = 'application/json';
  settings.success = processResult;

  //Use canvas function to query
  Sfdc.canvas.client.ajax ( finalUrl , settings );

  function processResult(data) {
    //ajax result
    if(data.status===200) {
      if(data.payload.records.length===0){
          alert( changesObject.resource[0] + ' was not found.');
          action.callbacks.cancel();
      }
      else {
          //id retrieved successfully, remove resource from changesObject and add Id
          var id = data.payload.records[0].Id;
          delete changesObject.resource;
          changesObject[idField] = id;
          action.callbacks.confirm();
      }
    }
    else {
      alert('There was an error looking up the Id. Please make sure the Name is correct.');
      action.callbacks.cancel();
    }
  }

}
